Bug 216800 - cad/ngspice_rework: Add option to build as shared library
Summary: cad/ngspice_rework: Add option to build as shared library
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: Richard Gallamore
URL:
Keywords: easy, needs-qa
Depends on:
Blocks:
 
Reported: 2017-02-04 23:19 UTC by Kevin Zheng
Modified: 2017-07-26 23:10 UTC (History)
1 user (show)

See Also:


Attachments
Patch (3.56 KB, patch)
2017-02-04 23:19 UTC, Kevin Zheng
koobs: maintainer-approval+
Details | Diff
Updated patch (3.61 KB, patch)
2017-07-24 21:42 UTC, Kevin Zheng
kevinz5000: maintainer-approval+
Details | Diff
Updated patch (3.61 KB, patch)
2017-07-25 06:05 UTC, Kevin Zheng
kevinz5000: maintainer-approval+
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Kevin Zheng 2017-02-04 23:19:34 UTC
Created attachment 179620 [details]
Patch

Add option to build as shared library. While here:

- Enable CIDER
- Update pkg-descr
Comment 1 Kevin Zheng 2017-06-20 23:46:37 UTC
I submitted this patch 4 months ago. Any work on getting it committed?
Comment 2 Kubilay Kocak freebsd_committer freebsd_triage 2017-07-19 11:39:58 UTC
Apologies for the delay Kevin. In future please set the 'maintainer-approval' flag on attachments to "+" for ports you are maintainer of, which will help to ensure it doesn't get missed as ready to go. Attachment -> Details -> maintainer-approval [+]
Comment 3 Richard Gallamore freebsd_committer 2017-07-24 18:37:32 UTC
Please fix portlint items.

portlint -A:
WARN: Makefile: USE_* seen before USES.  According to the porters-handbook, USES must appear first.                                                                                                                                           
WARN: /usr/local/poudriere/ports/test/cad/ngspice_rework/pkg-plist: [8]: installing shared libraries, please define USE_LDCONFIG as appropriate                                                                                               
WARN: /usr/local/poudriere/ports/test/cad/ngspice_rework/pkg-plist: [9]: installing shared libraries, please define USE_LDCONFIG as appropriate                                                                                               
WARN: Makefile: for new port, make $FreeBSD$ tag in comment section empty, to make SVN happy.                                                                                                                                                 
WARN: Makefile: new ports should not set PORTREVISION.                                                                                                                                                                                        
WARN: Makefile: Consider defining LICENSE.                                                                                                                                                                                                    
0 fatal errors and 6 warnings found.
Comment 4 Kevin Zheng 2017-07-24 21:28:58 UTC
(In reply to Richard Gallamore from comment #3)
Thank you; I'll address the USE_LDCONFIG issue.

In the future please read the issues you're asking me to fix. Specifically:

> WARN: Makefile: USE_* seen before USES.  According to the porters-handbook,
> USES must appear first. 

Did you look at the Makefile? USE_* never appears and there is an X11_USE *below* the USES. I suspect a bug in portlint.

> WARN: Makefile: for new port, make $FreeBSD$ tag in comment section empty, to
> make SVN happy.

This is not a new port.

> WARN: Makefile: new ports should not set PORTREVISION.

This is not a new port.

> WARN: Makefile: Consider defining LICENSE.

The port's COPYING makes it clear that there's not a single license that fits the bill. I could research multi-licensing and getting it in our infrastructure, but I don't understand why this is blocking an unrelated update.
Comment 5 Kevin Zheng 2017-07-24 21:42:18 UTC
Created attachment 184679 [details]
Updated patch

Updated patch attached. Fixes LICENSE and USE_LDCONFIG.
Comment 6 Richard Gallamore freebsd_committer 2017-07-24 21:55:32 UTC
(In reply to Kevin Zheng from comment #4)
Yes, I did read them and the -A option adds all checks which tend to trigger false positives, I just copy and pasted the output. The first item was recently added to portlint, it does seem to be a false positive and at first glance my guess is due to no other USE_x entries. I was only concerned about USE_LDCONFIG and license, sorry that I didn't make this clear.
Comment 7 Richard Gallamore freebsd_committer 2017-07-24 22:09:16 UTC
 I noticed options_single is being used for X11 and SHLIB, was this a mistake? This allows for only one or the other option being selected. Can X11 and SHLIB both not be enabled or disabled at the same time?

The USE_* is now a valid portlint item, Start this section with defining USES, and then possible USE_x.(13.1.7)[1]

[1] https://www.freebsd.org/doc/en/books/porters-handbook/porting-samplem.html#porting-samplem-order
Comment 8 Kevin Zheng 2017-07-25 06:05:18 UTC
Created attachment 184689 [details]
Updated patch

Patch updated. The ngspice documentation indicates that only one interface (shlib being one of them) can be specified. I haven't done enough testing to throw the switch so they should be mutually exclusive for the time being.
Comment 9 Richard Gallamore freebsd_committer 2017-07-26 23:10:12 UTC
Committed, thanks!
Comment 10 commit-hook freebsd_committer 2017-07-26 23:10:52 UTC
A commit references this bug:

Author: ultima
Date: Wed Jul 26 23:09:46 UTC 2017
New revision: 446703
URL: https://svnweb.freebsd.org/changeset/ports/446703

Log:
  * Enabled CIDER
  * Added New option, SHLIB, only X11 or SHLIB can be selected, X11 is the default
  * Moved Uses to start Uses section block
  * Sorted option section to better comply with handbook (13.1.8)[1]

  [1] https://www.freebsd.org/doc/en/books/porters-handbook/porting-samplem.html#porting-samplem-order

  PR:		216800
  Submitted by:	Kevin Zheng <kevinz5000@gmail.com> (maintainer)
  Reviewed by:	lifanov (mentor)
  Approved by:	lifanov (mentor)
  Differential Revision:	https://reviews.freebsd.org/D11729

Changes:
  head/cad/ngspice_rework/Makefile
  head/cad/ngspice_rework/pkg-descr
  head/cad/ngspice_rework/pkg-plist